"{ Package: 'stx:goodies/monticello' }"

MCRepository subclass:#MCGOODSRepository
	instanceVariableNames:'hostname port connection'
	classVariableNames:''
	poolDictionaries:''
	category:'Monticello-Repositories'
!


!MCGOODSRepository class methodsFor:'as yet unclassified'!

creationTemplate
	^
'MCGOODSRepository
	host: ''localhost''
	port: 6100'
!

description
	^ 'GOODS'
!

host: hostname port: portNumber
	^ self new
		host: hostname;
		port: portNumber
! !

!MCGOODSRepository methodsFor:'as yet unclassified'!

basicStoreVersion: aVersion
	self root at: aVersion info put: aVersion.
	self db commit.
!

db
	(connection isNil or: [connection isConnected not]) ifTrue: [
		connection := Smalltalk at: #KKDatabase ifPresent: [:cl | 
			cl  onHost:hostname port: port
		]
	].
	^ connection
!

description
	^ 'goods://', hostname asString, ':', port asString
!

host: aString
	hostname := aString
!

packages
	^ (self root collect: [:ea | ea package]) asSet asSortedCollection
!

port: aNumber
	port := aNumber
!

root
	self db root ifNil: [self db root: Dictionary new].
	^ self db root
!

versionWithInfo: aVersionInfo ifAbsent: errorBlock
	^ self root at: aVersionInfo ifAbsent: errorBlock
!

versionsAvailableForPackage: aPackage
	^ self root asArray select: [:ea | ea package = aPackage] thenCollect: [:ea | ea info]
! !

!MCGOODSRepository class methodsFor:'documentation'!

version
    ^ '$Header: /cvs/stx/stx/goodies/monticello/MCGOODSRepository.st,v 1.2 2011-08-20 11:44:04 cg Exp $'
!

version_CVS
    ^ '$Header: /cvs/stx/stx/goodies/monticello/MCGOODSRepository.st,v 1.2 2011-08-20 11:44:04 cg Exp $'
!

version_SVN
    ^ 'Id: MCGOODSRepository.st 5 2010-08-29 07:30:29Z vranyj1 '
! !
